/**
 * Version 1.0 is to handle individual single variable 2DSquareCelled raster data.
 * Copyright (C) 2005 Andy Turner, CCG, University of Leeds, UK.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
package uk.ac.leeds.ccg.andyt.grids.core;
// uk.ac.leeds.ccg.andyt.grids dependencies
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellAbstract.ChunkID;

/**
 * TODO:
 * docs
 */
public class Grid2DSquareCellIntChunkArrayFactory extends Grid2DSquareCellIntChunkAbstractFactory {
    
    /**
     * Creates a new Grid2DSquareCellIntChunkArrayFactory.
     */
    public Grid2DSquareCellIntChunkArrayFactory(){}
    
    /**
     * @see Grid2DSquareCellIntChunkAbstract
     */
    public Grid2DSquareCellIntChunkAbstract createGrid2DSquareCellIntChunk() {
        return new Grid2DSquareCellIntChunkArray();
    }
    
    /**
     * @see Grid2DSquareCellIntChunkAbstract
     */
    public Grid2DSquareCellIntChunkAbstract createGrid2DSquareCellIntChunk( Grid2DSquareCellInt grid2DSquareCellInt, ChunkID chunkID ) {
        return new Grid2DSquareCellIntChunkArray( grid2DSquareCellInt, chunkID );
    }
    
    /**
     * @see Grid2DSquareCellIntChunkAbstract
     */
    public Grid2DSquareCellIntChunkAbstract createGrid2DSquareCellIntChunk(Grid2DSquareCellIntChunkAbstract grid2DSquareCellIntChunk, ChunkID chunkID) {
        return new Grid2DSquareCellIntChunkArray( grid2DSquareCellIntChunk, chunkID );
    }
    
}
