/**
 * Version 1.0 is for examples of the use of the uk.ac.leeds.ccg.andyt.grids code base.
 * Copyright (C) 2005 Andy Turner, CCG, University of Leeds, UK.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
package uk.ac.leeds.ccg.andyt.grids.examples;
// java dependencies
import java.io.File;
import java.io.FileNotFoundException;
//import java.io.FilenameFilter;
import java.io.FileOutputStream;
import java.io.PrintWriter;
// uk.ac.leeds.ccg.andyt.grids dependencies
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble;
import uk.ac.leeds.ccg.andyt.grids.exchange.ImageExporter;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleFactory;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleChunk64CellMapFactory;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleChunkAbstractFactory;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleChunkArrayFactory;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleChunkJAIFactory;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleChunkMapFactory;
import uk.ac.leeds.ccg.andyt.grids.process.Grid2DSquareCellProcessor;
import uk.ac.leeds.ccg.andyt.grids.utilities.FileCreator;
import uk.ac.leeds.ccg.andyt.grids.utilities.Utilities;

/**
 * TODO:
 * docs
 */
public class ExporterRuns extends Run implements Runnable {
    
    /** Creates a new ExchangeRuns */
    public ExporterRuns() {
        super();
    }
    
    /**
     * Creates a new ExchangeRuns using specified workspace.
     * WARNING: Files in the specified workspace may get overwritten.
     */
    public ExporterRuns( File workspace ) {
        super( workspace );
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws java.io.IOException {
        File workspace = new File( "C:/Documents and Settings/geoagdt/My Documents/src/andyt/java/grids/data/TestData/" );
        ExporterRuns er = new ExporterRuns( workspace );
        er.run();
    }
    
    public void run() {
        long time = System.currentTimeMillis();
        //getFilenames();
        test0();
        //asrtm0();
        //srtm0();
        System.out.println( "Processing complete in " + Utilities.time( System.currentTimeMillis() - time ) );
    }
    
//    public String[] getFilenames() {
//        String dataDirectoryName = new String( "C:/work/Projects/Desertlinks/Scratch/agri_combined034/adem/" );
//        File dataDirectory = new File( dataDirectoryName );
//        //String[] asciifiles = dataDirectory.list( ); 
//        File[] asciifiles = dataDirectory.listFiles(); 
//        for ( int i = 0; i < asciifiles.length; i ++ ) {
//            System.out.println( asciifiles[ i ] );
//        }
//        return null;
//        //asciifiles;
//    }
    
//    public void asrtm0() {
//        System.out.println( "asrtm0()" );
//        Grid2DSquareCellDoubleJAIFactory jf = new Grid2DSquareCellDoubleJAIFactory();
//        Grid2DSquareCellDoubleFactory f = new Grid2DSquareCellDoubleFactory();
//        AbstractGrid2DSquareCellDoubleFactory gridFactory = f;
//        String dataDirectory = new String( "C:/work/Projects/Desertlinks/Scratch/agri_combined034/adem/" );
//        String filename = null;
//        AbstractGrid2DSquareCellDouble grid;
//        for ( int i = 2; i <= 53; i ++ ) {
//            filename = new String( "t" + i );
//            grid = gridFactory.createGrid2DSquareCellDouble( new File( dataDirectory, filename + ".asc" ) );
//            System.out.println( "grid loaded" );
//            System.out.println( grid.toString() );
//            Grid2DSquareCellDoubleExchange.toImage( grid, new File ( dataDirectory, filename + ".png" ), "PNG" );
//            System.out.println( "grid exported" );
//        }
//    }
    
    public void test0() {
        File workspace = super.grid2DSquareCellDoubleProcessor.getWorkspace();
        //this.grid2DSquareCellDoubleProcessor.setWorkspace( new File( workspace.toString(), "workspace" ) );
        log( "test0() {" );
        File inputFile = new File( workspace, "test1.asc" );
        log( "Set Grid2DSquareCellDouble Factory to use" );
        //Grid2DSquareCellDoubleFactory gridFactory = grid2DSquareCellDoubleProcessor.grid2DSquareCellDouble0Factory;
        Grid2DSquareCellDoubleFactory gridFactory = new Grid2DSquareCellDoubleFactory();
        log( "Set Grid2DSquareCellDoubleChunk Factory to use" );
        Grid2DSquareCellDoubleChunkAbstractFactory chunkFactory = new Grid2DSquareCellDoubleChunk64CellMapFactory();
        //Grid2DSquareCellDoubleChunkAbstractFactory chunkFactory = this.getGrid2DSquareCellDoubleChunkArrayFactory();
        //Grid2DSquareCellDoubleChunkAbstractFactory chunkFactory = this.getGrid2DSquareCellDoubleChunkJAIFactory();
        //Grid2DSquareCellDoubleChunkAbstractFactory chunkFactory = this.getGrid2DSquareCellDoubleChunkMapFactory();
        log( "Creating grid" );
        Grid2DSquareCellDouble grid2DSquareCellDouble = gridFactory.createGrid2DSquareCellDouble( inputFile );
        //grid2DSquareCellDouble.grid2DSquareCellDoubleProcessor = this.grid2DSquareCellDoubleProcessor;
        log( "Creating image from grid" );
        new ImageExporter().toGreyScaleImage( grid2DSquareCellDouble, new File( inputFile.getPath().substring( 0, inputFile.getPath().toCharArray().length - 3 ) + "png" ), "PNG" );
        log( "}" );
        //this.grid2DSquareCellDoubleProcessor.getLog().flush();
        //this.grid2DSquareCellDoubleProcessor.getLog().close();
        
    }
        

//    public void srtm0() {
//        System.out.println( "srtm0() {" );
//        Grid2DSquareCellDoubleFileFactory ff = new Grid2DSquareCellDoubleFileFactory();
//        AbstractGrid2DSquareCellDoubleFactory gridFactory = ff;
//        String dataDirectory = new String( "C:/work/data/dem/srtm/dem/n20e020/" );
//        String filename = new String( "dem_n20e020" );
//        File inFile = new File( dataDirectory, filename + ".asc" );
//        AbstractGrid2DSquareCellDouble grid = gridFactory.createGrid2DSquareCellDouble( inFile );
//        System.out.println( "grid loaded" );
//        System.out.println( grid.toString() );
//        File outFile = new File( dataDirectory, filename + ".grd" );
//        Grid2DSquareCellDoubleExchange.toBinaryFile( grid, outFile );
//        System.out.println( "grid exported" );
//        grid.clear();
//    }
//    
//    public void srtm1() {
//        System.out.println( "srtm1()" );
//        Grid2DSquareCellDoubleFileFactory ff = new Grid2DSquareCellDoubleFileFactory();
//        Grid2DSquareCellDoubleJAIFactory jf = new Grid2DSquareCellDoubleJAIFactory();
//        AbstractGrid2DSquareCellDoubleFactory gridFactory = ff;
//        String dataDirectory = new String( "C:/work/data/dem/srtm/dem/n20e020/" );
//        String filename = new String( "grids" );
//        File inFile = new File( dataDirectory, filename + ".asc" );
//        AbstractGrid2DSquareCellDouble grid = gridFactory.createGrid2DSquareCellDouble( inFile );
//        System.out.println( "grid loaded" );
//        System.out.println( grid.toString() );
//        File outFile = new File( dataDirectory, filename + ".grd" );
//        Grid2DSquareCellDoubleExchange.toBinaryFile( grid, outFile );
//        System.out.println( "grid exported" );
//        grid.clear();
//    }
}
