/*
 * Grid2DSquareCellDoubleTest.java
 * JUnit based test
 *
 * Created on 05 February 2005, 12:45
 */

package uk.ac.leeds.ccg.andyt.grids.core;

import junit.framework.*;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellAbstract.ChunkID;
import uk.ac.leeds.ccg.andyt.grids.exchange.ESRIAsciiGridImporter;
import uk.ac.leeds.ccg.andyt.grids.utilities.Utilities;

/**
 *
 * @author geoagdt
 */
public class Grid2DSquareCellDoubleTest extends TestCase {
    
    public Grid2DSquareCellDoubleTest(String testName) {
        super(testName);
    }

    protected void setUp() throws java.lang.Exception {
    }

    protected void tearDown() throws java.lang.Exception {
    }

    public static junit.framework.Test suite() {
        junit.framework.TestSuite suite = new junit.framework.TestSuite(Grid2DSquareCellDoubleTest.class);
        
        return suite;
    }
    
    public Grid2DSquareCellDouble constructFromESRIAsciigridTestData() {
        File inputFile = new File( "C:/Work/src/andyt/java/grids/data/TestData/Grid2DSquareCellDouble/Test0/" );
        //File inputFile = new File( "C:/Work/src/andyt/java/grids/data/TestData/Grid2DSquareCellDouble/Test0" );
        File grid2DSquareCellDoubleDirectory = new File( "C:/Work/src/andyt/java/grids/data/TestData/Grid2DSquareCellDouble/Test0");
        Grid2DSquareCellDouble grid2DSquareCellDouble = constructFromFile( inputFile, grid2DSquareCellDoubleDirectory );
        long time = System.currentTimeMillis();
        File inputFile = new File( "C:/Work/src/andyt/java/grids/data/TestData/ESRIAsciigrid/Test0.asc" );
        File grid2DSquareCellDoubleDirectory = new File( "C:/Work/src/andyt/java/grids/data/TestData/Grid2DSquareCellDouble/Test0" );
        boolean mkdir = grid2DSquareCellDoubleDirectory.mkdir();
        if ( mkdir ) {
            System.out.println( "Made directory " + grid2DSquareCellDoubleDirectory.toString() );
        } else {
            System.out.println( "Failed to make directory " + grid2DSquareCellDoubleDirectory.toString() );
        }
        Grid2DSquareCellDoubleFactory grid2DSquareCellDoubleFactory = new Grid2DSquareCellDoubleFactory( grid2DSquareCellDoubleDirectory );
        Grid2DSquareCellDouble grid2DSquareCellDoubleAbstract = grid2DSquareCellDoubleFactory.createGrid2DSquareCellDouble( inputFile );
        Grid2DSquareCellDouble result = ( Grid2DSquareCellDouble ) grid2DSquareCellDoubleAbstract;
        //printStats( result );
        return result;
    }

    public Grid2DSquareCellDouble constructFromGrid2DSquareCellDoubleCache() {
        long time = System.currentTimeMillis();
        File inputFile = new File( "C:/Work/src/andyt/java/grids/data/TestData/Grid2DSquareCellDouble/Test0" );
        Grid2DSquareCellDoubleFactory grid2DSquareCellDoubleFactory = new Grid2DSquareCellDoubleFactory( inputFile );
        Grid2DSquareCellDouble grid2DSquareCellDoubleAbstract = grid2DSquareCellDoubleFactory.createGrid2DSquareCellDouble( inputFile );
        Grid2DSquareCellDouble result = ( Grid2DSquareCellDouble ) grid2DSquareCellDoubleAbstract;
        //printStats( result );
        return result;
    }
    
    public Grid2DSquareCellDouble constructFromFile( File inputFile, File grid2DSquareCellDoubleDirectory ) {
        try {
            if ( ! inputFile.exists() ) {
                throw new Exception( "File( " + inputFile.toString() + " does not exist" );
            }
        } catch ( Exception e ) {
            System.out.println( e.getMessage() );
            e.printStackTrace();
        }
        if ( grid2DSquareCellDoubleDirectory.exists() ) {
            if ( grid2DSquareCellDoubleDirectory.list().length != 0 ) {
                System.out.println("Warning files in " + grid2DSquareCellDoubleDirectory.toString() + " may be overwritten." );
            }
        } else {
            try {
                grid2DSquareCellDoubleDirectory.mkdir();
            } catch ( Exception e0 ) {
                e0.printStackTrace();
            }
        }
        long time = System.currentTimeMillis();
        Grid2DSquareCellDoubleFactory grid2DSquareCellDoubleFactory = new Grid2DSquareCellDoubleFactory( grid2DSquareCellDoubleDirectory );
        Grid2DSquareCellDouble grid2DSquareCellDoubleAbstract = grid2DSquareCellDoubleFactory.createGrid2DSquareCellDouble( inputFile );
        Grid2DSquareCellDouble result = ( Grid2DSquareCellDouble ) grid2DSquareCellDoubleAbstract;
        //printStats( result );
        return result;
    }
    
    
//    public void printStats( Grid2DSquareCellDoubleChunkAbstract grid2DSquareCellDoubleChunk ) {
//        log( "Stats for " + grid2DSquareCellDoubleChunk.getGrid2DSquareCellDouble().toString() + "( chunkID( " + grid2DSquareCellDoubleChunk.chunkID.toString() + " ), Grid2DSquareCellDoubleChunk( " + grid2DSquareCellDoubleChunk.toString() + " ) )" );
//        log( "  ArithmeticMean : " + grid2DSquareCellDoubleChunk.getArithmeticMean() );
//        //log( "  GeometricMean : " + grid2DSquareCellDoubleChunk.getGeometricMean() );
//        //log( "  HarmonicMean : " + grid2DSquareCellDoubleChunk.getHarmonicMean() );
//        //        log( "Mode : " );
//        //        if (true){
//        //            TDoubleHashSet mode = grid2DSquareCellDoubleChunk.getMode();
//        //            log( "" + mode.size() + " values : ");
//        //            TDoubleIterator iterator = mode.iterator();
//        //            for ( int i = 0; i < mode.size(); i ++ ) {
//        //                log( iterator.next() + " " );
//        //            }
//        //        }
//        //        log("");
//        log( "  Median : " + grid2DSquareCellDoubleChunk.getMedian() );
//        log( "  StandardDeviation : " + grid2DSquareCellDoubleChunk.getStandardDeviation() );
//    }
//    
//    public void printStats( Grid2DSquareCellDouble grid2DSquareCellDouble ) {
//        log( "Stats for " + grid2DSquareCellDouble.toString() + "( " + grid2DSquareCellDouble.getName() + " )" );
//        log( "  ArithmeticMean : " + grid2DSquareCellDouble.getArithmeticMean() );
//        //log( "  GeometricMean : " + grid2DSquareCellDoubleChunk.getGeometricMean() );
//        //log( "  HarmonicMean : " + grid2DSquareCellDoubleChunk.getHarmonicMean() );
//        //        log( "  Mode : " );
//        //        if (true){
//        //            TDoubleHashSet mode = grid2DSquareCellDouble.getMode();
//        //            log( "" + mode.size() + " values : ");
//        //            TDoubleIterator iterator = mode.iterator();
//        //            for ( int i = 0; i < mode.size(); i ++ ) {
//        //                log( iterator.next() + " " );
//        //            }
//        //        }
//        //        log("");
//        //log( "  Median : " + grid2DSquareCellDouble.getMedian() );
//        log( "  StandardDeviation : " + grid2DSquareCellDouble.getStandardDeviation() );
//    }
    
    
    
    /**
     * Test of toString method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testToString() {
        System.out.println("testToString");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of initAll method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testInitAll() {
        System.out.println("testInitAll");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getGrid2DSquareCellDoubleChunk method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetGrid2DSquareCellDoubleChunk() {
        System.out.println("testGetGrid2DSquareCellDoubleChunk");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of clear method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testClear() {
        System.out.println("testClear");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getNoDataValue method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetNoDataValue() {
        System.out.println("testGetNoDataValue");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getNoDataValueBigDecimal method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetNoDataValueBigDecimal() {
        System.out.println("testGetNoDataValueBigDecimal");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of initNoDataValue method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testInitNoDataValue() {
        System.out.println("testInitNoDataValue");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getCell method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetCell() {
        System.out.println("testGetCell");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of setCell method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testSetCell() {
        System.out.println("testSetCell");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of initCell method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testInitCell() {
        System.out.println("testInitCell");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of initCellFast method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testInitCellFast() {
        System.out.println("testInitCellFast");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getCells method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetCells() {
        System.out.println("testGetCells");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getNearestValueDouble method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetNearestValueDouble() {
        System.out.println("testGetNearestValueDouble");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getNearestValuesCellIDs method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetNearestValuesCellIDs() {
        System.out.println("testGetNearestValuesCellIDs");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getNearestValueDoubleDistance method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testGetNearestValueDoubleDistance() {
        System.out.println("testGetNearestValueDoubleDistance");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of addToCell method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testAddToCell() {
        System.out.println("testAddToCell");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of iterator method, of class uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble.
     */
    public void testIterator() {
        System.out.println("testIterator");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }
    
    // TODO add test methods here. The name must begin with 'test'. For example:
    // public void testHello() {}
    
}
