/*
 * UtilitiesTest.java
 * JUnit based test
 *
 * Created on 05 February 2005, 11:30
 */

package uk.ac.leeds.ccg.andyt.grids.util;

import junit.framework.*;
import java.io.File;
import java.io.StreamTokenizer;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.RandomAccessFile;
import java.io.IOException;
import java.io.FilenameFilter;
import java.math.BigDecimal;
import java.util.Vector;
import java.util.TreeSet;
import java.util.Iterator;
import java.awt.Frame;
import java.awt.FileDialog;
import java.awt.image.Raster;
import java.awt.image.SampleModel;
import java.awt.image.ColorModel;
import javax.imageio.ImageIO;
import java.awt.geom.Point2D;
import java.io.BufferedOutputStream;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellAbstract;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleFactory;
import uk.ac.leeds.ccg.andyt.grids.utilities.Utilities;

/**
 *
 * @author geoagdt
 */
public class UtilitiesTest extends TestCase {
    
    public UtilitiesTest(String testName) {
        super(testName);
    }

    protected void setUp() throws java.lang.Exception {
    }

    protected void tearDown() throws java.lang.Exception {
    }

    public static junit.framework.Test suite() {
        junit.framework.TestSuite suite = new junit.framework.TestSuite(UtilitiesTest.class);
        
        return suite;
    }
    
    public void arrayGarbageCollectionTest() {
        System.out.println(Runtime.getRuntime().freeMemory());
        System.gc();
        System.out.println(Runtime.getRuntime().freeMemory());
        System.gc();
        System.out.println(Runtime.getRuntime().freeMemory());
        Integer[] int1 = new Integer[10000000];
        for ( int i = 0; i < 10000000; i ++ ) {
            int1[i] = new Integer(i);
        }
        System.out.println(Runtime.getRuntime().freeMemory());
        for ( int i = 5000000; i < 10000000; i ++ ) {
            int1[i] = null;
        }
        System.gc();
        System.out.println(Runtime.getRuntime().freeMemory());
        int1 = null;
        System.gc();
        System.out.println(Runtime.getRuntime().freeMemory());
    }
    
   public void intTest() {
       long l0;
       int i0;
       for ( long i = 0; i < 10; i ++ ) {
           l0 = ( long ) Integer.MAX_VALUE + i;
           i0 = ( int ) l0;
           System.out.println( "long " + l0 + " int " + i0 );
       }
       for ( long i = 0; i < 10; i ++ ) {
           l0 = ( long ) Long.MAX_VALUE + i;
           i0 = ( int ) l0;
           System.out.println( "long " + l0 + " int " + i0 );
       }
       for ( long i = 0; i < 10; i ++ ) {
           l0 = ( long ) Long.MAX_VALUE * i;
           i0 = ( int ) l0;
           System.out.println( "long " + l0 + " int " + i0 );
       }
   }
    
//    public void primes() {
//        int numberOfPrimes = 16;
//        //int numberOfPrimes = 25;
//        //int numberOfPrimes = 36;
//        //int numberOfPrimes = 64;
//        //int numberOfPrimes = 256;
//        //int numberOfPrimes = 100008; // All
//        int[] primes = Utilities.getPrimesFrom2( numberOfPrimes );
//        BigInteger intMax_Value = new BigInteger( new Integer( Integer.MAX_VALUE ).toString() );
//        BigInteger longMax_Value = new BigInteger( new Long( Long.MAX_VALUE ).toString() );
//        int productOfPrimesInt = primes[0];
//        long productOfPrimesLong = primes[0];
//        boolean stop0 = false;
//        boolean stop1 = false;
//        BigInteger productOfPrimesBigInteger = new BigInteger( new Integer( primes[0] ).toString() );
//        for ( int prime = 1; prime < primes.length; prime ++ ) {
//            productOfPrimesBigInteger = productOfPrimesBigInteger.multiply( new BigInteger( new Integer( primes[prime] ).toString() ) );
//            if ( ! ( stop0 && stop1 ) ) {
//                if ( productOfPrimesBigInteger.compareTo( intMax_Value ) == 1 && ! stop0 ) {
//                    System.out.println( "Too big for int precision with only " + ( prime + 1 ) + " primes" );
//                    System.out.println( "Return " + ( ( int ) Math.floor( Math.sqrt( ( double ) ( prime + 1 ) ) ) ) );
//                    System.out.println( "productOfPrimesBigInteger " + productOfPrimesBigInteger );
//                    System.out.println( "productOfPrimesInt        " + productOfPrimesInt );
//                    System.out.println( "Integer.MAX_VALUE         " + Integer.MAX_VALUE );
//                    System.out.println( "primes[ " + ( prime - 1 ) + " ] " + primes[ prime - 1 ] );
//                    System.out.println( "primes[ " + prime + " ] " + primes[ prime ] );
//                    stop0 = true;
//                } else {
//                    if ( ! stop0 ) {
//                        productOfPrimesInt *= primes[prime];
//                    }
//                }
//                if ( productOfPrimesBigInteger.compareTo( longMax_Value ) == 1 && ! stop1 ) {
//                    System.out.println( "Too big for long precision with only " + ( prime + 1 ) + " primes" );
//                    System.out.println( "Return " + ( ( int ) Math.floor( Math.sqrt( ( double ) ( prime + 1 ) ) ) ) );
//                    System.out.println( "productOfPrimesBigInteger " + productOfPrimesBigInteger );
//                    System.out.println( "productOfPrimesLong       " + productOfPrimesLong );
//                    System.out.println( "Long.MAX_VALUE            " + Long.MAX_VALUE );
//                    System.out.println( "primes[ " + ( prime - 1 ) + " ] " + primes[ prime - 1 ] );
//                    System.out.println( "primes[ " + prime + " ] " + primes[ prime ] );
//                    stop1 = true;
//                } else {
//                    if ( ! stop1 ) {
//                        productOfPrimesLong *= primes[prime];
//                    }
//                }
//            }
//        }
//        System.out.println( "productOfPrimesBigInteger " + productOfPrimesBigInteger );
//        System.out.println( "primes[ " + ( numberOfPrimes - 1 ) + " ] " + primes[ numberOfPrimes - 1 ] );
//        //Utilities.exportIntArray( primes, new File( "c:/work/src/andyt/grids/data/utilities/First" + numberOfPrimes + "PrimeNumbers.dat" ) );
//    }
    
    public void tollerance() {
        double valueALittleBitLarger;
        double valueALittleBitSmaller;
        for ( int i = 1; i < 1000000000; i *= 10 ) {
            valueALittleBitLarger = ( - 1.0d / ( double ) i );
            valueALittleBitSmaller = ( - 1.0d / ( double ) i );
            for ( int j = 1; j < 100; j ++ ) {
                System.out.print( "Value a little bit larger than " + valueALittleBitLarger );
                valueALittleBitLarger = Utilities.getValueALittleBitLarger( valueALittleBitLarger );
                System.out.println( " is " + valueALittleBitLarger );
                System.out.print( "Value a little bit smaller than " + valueALittleBitSmaller );
                valueALittleBitSmaller = Utilities.getValueALittleBitSmaller( valueALittleBitSmaller );
                System.out.println( " is " + valueALittleBitSmaller );
            }
            valueALittleBitLarger = ( 1.0d / ( double ) i );
            valueALittleBitSmaller = ( 1.0d / ( double ) i );
            for ( int j = 1; j < 100; j ++ ) {
                System.out.print( "Value a little bit larger than " + valueALittleBitLarger );
                valueALittleBitLarger = Utilities.getValueALittleBitLarger( valueALittleBitLarger );
                System.out.println( " is " + valueALittleBitLarger );
                System.out.print( "Value a little bit smaller than " + valueALittleBitSmaller );
                valueALittleBitSmaller = Utilities.getValueALittleBitSmaller( valueALittleBitSmaller );
                System.out.println( " is " + valueALittleBitSmaller );
            }
            valueALittleBitLarger = ( ( double ) - i );
            valueALittleBitSmaller = ( ( double ) - i );
            for ( int j = 1; j < 100; j ++ ) {
                System.out.print( "Value a little bit larger than " + valueALittleBitLarger );
                valueALittleBitLarger = Utilities.getValueALittleBitLarger( valueALittleBitLarger );
                System.out.println( " is " + valueALittleBitLarger );
                System.out.print( "Value a little bit smaller than " + valueALittleBitSmaller );
                valueALittleBitSmaller = Utilities.getValueALittleBitSmaller( valueALittleBitSmaller );
                System.out.println( " is " + valueALittleBitSmaller );
            }
            valueALittleBitLarger = ( ( double ) i );
            valueALittleBitSmaller = ( ( double ) i );
            for ( int j = 1; j < 100; j ++ ) {
                System.out.print( "Value a little bit larger than " + valueALittleBitLarger );
                valueALittleBitLarger = Utilities.getValueALittleBitLarger( valueALittleBitLarger );
                System.out.println( " is " + valueALittleBitLarger );
                System.out.print( "Value a little bit smaller than " + valueALittleBitSmaller );
                valueALittleBitSmaller = Utilities.getValueALittleBitSmaller( valueALittleBitSmaller );
                System.out.println( " is " + valueALittleBitSmaller );
            }
        }
    }
    
    
    /**
     * Test of memoryAllocation method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testMemoryAllocation() {
        System.out.println("testMemoryAllocation");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of exportIntArray method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testExportIntArray() {
        System.out.println("testExportIntArray");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of time method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testTime() {
        System.out.println("testTime");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getValueALittleBitLarger method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testGetValueALittleBitLarger() {
        System.out.println("testGetValueALittleBitLarger");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getValueALittleBitSmaller method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testGetValueALittleBitSmaller() {
        System.out.println("testGetValueALittleBitSmaller");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of getSamplePoints method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testGetSamplePoints() {
        System.out.println("testGetSamplePoints");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of distance method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testDistance() {
        System.out.println("testDistance");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of angle method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testAngle() {
        System.out.println("testAngle");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }

    /**
     * Test of densityPlot method, of class uk.ac.leeds.ccg.andyt.grids.util.Utilities.
     */
    public void testDensityPlot() {
        System.out.println("testDensityPlot");
        
        // TODO add your test code below by replacing the default call to fail.
        fail("The test case is empty.");
    }
    
    // TODO add test methods here. The name must begin with 'test'. For example:
    // public void testHello() {}
    
}
